
#ifndef _MOTION_H
#define _MOTION_H

#include "blepo.h"
#include "ransacfithomography.h"
#include "homography2D.h"
#include "configs.h"
#include <vector>

using namespace blepo;
using namespace std;

class MotionDetector {
public:
	static void ComputeNormalFlow(double gradAdd, double normThresh, ImgFloat& gradx, ImgFloat& grady, ImgFloat& gradT, ImgGray *mask);
	static void SubtractAfterWarping(ImgBgr& imgFrame, ImgBgr& prev_imgFrame, KltFeatureList& fl, KltTrackingContext& tc, ImgGray *const warpImage, ImgGray *const subtractedImage);
	static void WarpImage(const ImgGray& curr_image, const ImgGray& prev_image, KltFeatureList& fl, KltTrackingContext& tc, ImgGray *const warpImage);
	static void ComputeKltMotion(const ImgBgr& prev_frame, const ImgBgr& curr_frame, const ImgBinary& object_mask, Rect& context, float& du, float& dv, ImgBgr& display_image, int rgn_id);
	static void ComputeJointKltMotion(const ImgBgr& prev_frame, const ImgBgr& curr_frame, const ImgBinary& object_mask, Rect& context, float& du, float& dv, ImgBgr& display_image, int pyrlevel, int mindist, int rgn_id);
	static void HornSchunk(ImgGray& img1, ImgGray& img2, ImgFloat *vel_x, ImgFloat *vel_y);
	static void BlockMatch(ImgGray &img1, ImgGray &img2, ImgFloat *vel_x, ImgFloat *vel_y);
	//static void ComputeRegionMotion(const ImgBgr& prev_frame, const ImgBgr& curr_frame, const ImgBinary& object_mask1, const ImgBinary& object_mask2, Rect& context, float& du, float& dv, ImgBgr& display_image);
};

#endif