
#ifndef _OCCLUSIONHANDLER_H
#define _OCCLUSIONHANDLER_H

#include "TheTracker.h"
#include "ObjectModel.h"

class OcclusionHandler {
private:
	int m_width, m_height;
public:
	bool m_isObjectOccluded;
	int m_ShapeMatchFrameNo, m_ShapeIterateFrame;
	vector<Point> m_occluded_contour_pts;
	int m_end_occ_frame_no, m_start_occ_frame_no;

	OcclusionHandler(int width, int height);

	void MatchContour( int startSearchFrame,
					   int endSearchFrame, 
					   const vector<Shape>& contour_history, 
					   int& shapeMatchFrameNo,		/* OUT */
					   int& shapeIterateFrame );


	void HandleSingleObjectOcclussion(	int frame_count, 
										ObjectModel& object_model, /* OUT */
										ImgBgr &current_frame );


	void GetOccludedContourPoints(	ObjectModel& object_model,
									vector<Point> *occ_contourPts, 
									ImgBgr &display_image );
};

#endif
