
#ifndef _TRACKERMANAGER_H
#define _TRACKERMANAGER_H

#include "TheTracker.h"
#include "ObjectTracker.h"

class TrackerManager
{
private:
	int m_num_objects;
	int m_width, m_height;
	vector<ObjectTracker> m_objects;
public:
	~TrackerManager() {
		m_objects.empty();
		m_num_objects = 0;
	}

	TrackerManager(int width, int height);
	int AddObject(const ImgBgr &input_image, vector<Point>& points, double seg_sigma, ImgInt *const fg_label = NULL, ImgInt *const bg_label = NULL);
	void TrackNextFrame(ImgBgr &current_frame, int frame_no);
	void DrawContour(ImgBgr& display_image);
	void LoadStateFromFile(int object_id, const ImgInt& current_model);
};

#endif