/*
File		: c_matix.h
Description	: The C++ Template of class MatrixL
Copyright   : Liu Qiang
Warning		:  
date		: 03 - 24 - 2006
 *
 * ΪӦmatlab  c++ ϱ̶רƵģע¼
 *      ȣûڴ䣬ֻǽһַĹ캯Ҳ֧
 * ڴ泷ֻ൱һӡ
 *
 *   û趨еֵʵò 4096;
 *
 */
/*
 * three class:
 *
 *
*/
#ifndef  __MCMATRIX_H__
#define  __MCMATRIX_H__

#include <string>
#include <limits>

//the class of matrix error
class mcMatrixLE
{
public:
	mcMatrixLE (const std::string& str): errorstr(str){}
	std::string& description()
	{
		return errorstr;
	}
private:
	std::string errorstr;
};

/***************************************/
//******the class of my io matrix******//
/***************************************/
//
class mcDblMatrixL;
class mcIOMatrixL
{
public:
	// constructor from array
    mcIOMatrixL(double * elee, const int& row, const int& col)
                            : r(row), c(col), data(new double*[c])
    {
        data[0] =  elee;
        for (int i=1; i<c; i++)  data[i] =  data[i-1] + r;
    }
    //	deconstructor
	~mcIOMatrixL(){ if(data != NULL) delete []data; }
   
	// the row,column and data for the matrix.
	inline int mcRow()const { return r; }
	inline int mcCol()const { return c; }
    
	friend class mcDblMatrixL;

    void mcCopy(const mcDblMatrixL& rhs);
    void mcCopyShrink0(const mcDblMatrixL& rhs);
 
	// the index for the matrix
    inline double& operator() (const int& i,const int& j)				
    {
       //if ( (i>=r) || (i<0) || (j>=c) || (j<0))  
	   //	throw mcMatrixLE("Overflow in io matrix"); 
	   return data[j][i];	
	}
	
    inline double operator() (const int& i,const int& j) const
    {
      //if ( (i>=r) || (i<0) || (j>=c) || (j<0))  
	  //	throw mcMatrixLE("Overflow in io matrix"); 
	  return data[j][i];	
   }
   // ݾԳƷؾֵ,Ҽ賬ķΧǳ1!!!
    inline double atm0(int i, int j) const
    {
        // 
        if (i<0)        i = -i -1;
        else if(i>r-1)  i = r + r - i -1;
         
        //
        if (j<0)          j = -j -1;
        else if(j > c-1)  j = c + c - j -1;
        
       // ؾֵ
        return data[j][i];
    }
    
    // ֵ߽Ϊ
    inline  double atminf(int i,int j) const
    {
        if ( (i>=r) || (i<0) || (j>=c) || (j<0))  return DBL_MAX;
        return data[j][i];
    }
private:
	int			r;					//  the row			of the matrix
	int			c;					//  the column	of the matrix
	double **	data;				//  the element	of the matrix
    
private:
    mcIOMatrixL  (){}
    mcIOMatrixL(const mcIOMatrixL&){}
	const mcIOMatrixL & operator = (const mcIOMatrixL&){}
};
// end of mcIOMatrixL

/******************************************************/
// һ
class mcDblMatrixL
{
public:
	// constructor
	mcDblMatrixL  (): r(0), c(0), data(NULL){};
	mcDblMatrixL  (const int&,const int&);
    mcDblMatrixL  (const double &a, const int&,const int&);
    mcDblMatrixL  (const double *a, const int&,const int&);
    mcDblMatrixL  (const mcDblMatrixL&);
    
    // ֵ
	mcDblMatrixL & operator = (const mcDblMatrixL&);
    mcDblMatrixL & operator = (const double&);
    void mcCopy(const mcIOMatrixL& rhs);
    void mcCopyExpand0(const mcIOMatrixL& im);
    
    //	deconstructor
	~mcDblMatrixL()
    {
        if(data != NULL) 
        {
            delete [] (data[0]);
            delete [] (data);
        }
    }
     
	// the row,column and data for the matrix.
	inline int      mcRow()	const {	return r; }
	inline int      mcCol()	const {	return c; }
     
	// the index for the matrix
   inline double& operator() (const int& i,const int& j)				
   {
       //if ( (i>=r) || (i<0) || (j>=c) || (j<0))   
	   //   throw mcMatrixLE("Overflow in Double matrix");
		return data[i][j];	
   }
   inline double operator() (const int& i,const int& j) const
   {
       //if ( (i>=r) || (i<0) || (j>=c) || (j<0))   
	   //	throw mcMatrixLE("Overflow in Double matrix");
		return data[i][j];	
   }
   
   // ݾԳƷؾֵ,Ҽ賬ķΧǳ1!!!
    inline double atm0(int i, int j) const
    {
        // 
        if (i<0)        i = -i -1;
        else if(i>r-1)  i = r + r - i -1;
         
        //
        if (j<0)        j = -j-1;
        else if(j>c-1)  j = c + c - j -1;
        
       // ؾֵ
        return data[i][j];
    }
    inline  double atminf(int i,int j) const
    {
        if ( (i>=r) || (i<0) || (j>=c) || (j<0))  return DBL_MAX;
        return data[i][j];
    }
private:
	int			r;					//  the row			of the matrix
	int			c;					//  the column	of the matrix
	double **	data;				//  the element	of the matrix
};

// constructorٿռ䲻ֵ
mcDblMatrixL::mcDblMatrixL(const int& row, const int& col)
    :r(row), c(col), data(new double *[row])
{
    data[0] = new double[row*col];
    for(int i=1;i<row;i++) data[i] = data[i-1] + col;
}

// constructorٿռ丳ֵΪһֵ
 mcDblMatrixL::mcDblMatrixL(const double &a,const int& row, const int& col)
   :r(row), c(col), data(new double *[row])
{ 
    int i;
    data[0] = new double[row*col];
    for(i=1;i<row;i++)        data[i] = data[i-1] + col;
    for(i=0;i<row*col;i++)    data[0][i] = a;
   } 
// constructorٿռһָ븳ֵ
mcDblMatrixL::mcDblMatrixL  (const double *a, const int& row,const int& col)
   :r(row), c(col), data(new double *[row])
{ 
    int i;
    data[0] = new double[row*col];
    for(i=1;i<row;i++)      data[i] = data[i-1] + col;
    for(i=0;i<row*col;i++)  data[0][i] = a[i];
}
// constructorٿռһֵ
mcDblMatrixL::mcDblMatrixL (const mcDblMatrixL& rhs)
    :r(rhs.r),c(rhs.c),data(new double *[r])
 {
    int i;
    data[0] = new double[r*c];
    for(i=1;i<r;i++)    data[i] = data[i-1] + c;
    for(i=0;i<r*c;i++)  data[0][i] = rhs.data[0][i];
 }
// һںţ
mcDblMatrixL & mcDblMatrixL:: operator = (const mcDblMatrixL& rhs)
{
    if(&rhs != this)
    {
        int i,j;
        if ( (r*c) != (rhs.mcRow()*rhs.mcCol()) )
        {
            if (data != NULL)
            {
                delete [](data[0]);
                delete []data;
            }
            r = rhs.mcRow();
            c = rhs.mcCol();
            data    = new double *[r];
            data[0] = new double[r*c];
        }
        if (r != rhs.r)
        {
            r = rhs.mcRow();
            c = rhs.mcCol();
        }
        for(i=1;i<r;i++) data[i] = data[i-1] + c;
    
        for(i=0;i<r;i++)
            for(j=0;j<c;j++)
                data[i][j] = rhs(i,j);
    }
    return * this;
}

// صںţһԪ
mcDblMatrixL& mcDblMatrixL:: operator = (const double& a)
{
    for(int i=0;i<r*c;i++) data[0][i] = a;
    return * this;
}

// ƾ
void mcDblMatrixL:: mcCopy(const mcIOMatrixL& rhs)
{
	int i,j;
	if ( (r*c) != (rhs.mcRow()*rhs.mcCol()) )
	{
		if (data != NULL)
		{
			delete [](data[0]);
			delete []data;
		}
		r = rhs.mcRow();
		c = rhs.mcCol();
		data    = new double *[r];
		data[0] = new double[r*c];
	}

	if (r != rhs.mcRow())
	{
		r = rhs.mcRow();
		c = rhs.mcCol();
	}
	for(i=1;i<r;i++) data[i] = data[i-1] + c;

	for(i=0;i<r;i++)
		for(j=0;j<c;j++)
			data[i][j] = rhs(i,j);
}

// 
void mcDblMatrixL::mcCopyExpand0(const mcIOMatrixL& rhs)
{
    int i,j;
    if (r!=(rhs.mcRow()+2) || (c != (rhs.mcCol()+2))) 
		throw mcMatrixLE("not match in mcExpand0() in Dbl!");
   
    // interior
    for(i=1;i<r-1;i++)
      for(j=1;j<c-1;j++)
         data[i][j] = rhs(i-1,j-1);
   
    // boundary
    for(i=1;i<r-1;i++) 
    {
       data[i][0] = data[i][1];
       data[i][c-1] = data[i][c-2];
    }
    for(j=0;j<c;j++) 
    {
       data[0][j] = data[1][j];
       data[r-1][j] = data[r-2][j];
    }
} // end for mcDblMatrixL::mcCopyExpand0

// io ĸֵ
void mcIOMatrixL::mcCopy(const mcDblMatrixL& rhs)
{
    if (r!=(rhs.mcRow()) || (c != (rhs.mcCol()))) 
		throw mcMatrixLE("not match in dimension when copy() in io!");
      for(int i=0; i<r; i++)
            for(int j=0; j<c; j++)
                data[j][i] = rhs(i,j);
} // end for mcIOMatrixL::mcCopy

// io ĸֵ
void mcIOMatrixL::mcCopyShrink0(const mcDblMatrixL& rhs)
{
	if (r!=(rhs.mcRow()-2) || (c != (rhs.mcCol()-2))) 
		throw mcMatrixLE("not match in dimension when copy to im!");
    for(int i=0; i<r; i++)
		for(int j=0; j<c; j++)
			data[j][i] = rhs(i+1,j+1);
} // end for mcIOMatrixL::mcCopyExpand0


#endif